diff --git a/src/detect-dce-iface.c b/src/detect-dce-iface.c
index 76b6c00..9255a38 100644
--- a/src/detect-dce-iface.c
+++ b/src/detect-dce-iface.c
@@ -32,44 +32,6 @@ int DetectDceIfaceSetup(DetectEngineCtx *, Signature *s, SigMatch *m, char *arg)
 void DetectDceIfaceFree(void *);
 
 /**
- * \brief Registers the keyword handlers for the "dce_iface" keyword.
- */
-void DetectDceIfaceRegister(void)
-{
-    const char *eb;
-    int eo;
-    int opts = 0;
-
-    sigmatch_table[DETECT_DCE_IFACE].name = "dce_iface";
-    sigmatch_table[DETECT_DCE_IFACE].alproto = ALPROTO_DCERPC;
-    sigmatch_table[DETECT_DCE_IFACE].Match = NULL;
-    sigmatch_table[DETECT_DCE_IFACE].AppLayerMatch = DetectDceIfaceMatch;
-    sigmatch_table[DETECT_DCE_IFACE].Setup = DetectDceIfaceSetup;
-    sigmatch_table[DETECT_DCE_IFACE].Free  = DetectDceIfaceFree;
-    sigmatch_table[DETECT_DCE_IFACE].RegisterTests = DetectDceIfaceRegisterTests;
-
-    parse_regex = pcre_compile(DETECT_DCE_IFACE_PCRE_PARSE_ARGS, opts, &eb,
-                               &eo, NULL);
-    if (parse_regex == NULL) {
-        SCLogDebug("pcre compile of \"%s\" failed at offset %" PRId32 ": %s",
-                   DETECT_DCE_IFACE_PCRE_PARSE_ARGS, eo, eb);
-        goto error;
-    }
-
-    parse_regex_study = pcre_study(parse_regex, 0, &eb);
-    if (eb != NULL) {
-        SCLogDebug("pcre study failed: %s", eb);
-        goto error;
-    }
-
-    return;
-
- error:
-    /* we need to handle error?! */
-    return;
-}
-
-/**
  * \internal
  * \brief Parses the argument sent along with the "dce_iface" keyword.
  *
@@ -78,7 +40,7 @@ void DetectDceIfaceRegister(void)
  * \retval did Pointer to a DetectDceIfaceData instance that holds the data
  *             from the parsed arg.
  */
-static inline DetectDceIfaceData *DetectDceIfaceArgParse(const char *arg)
+static DetectDceIfaceData *DetectDceIfaceArgParse(const char *arg)
 {
     DetectDceIfaceData *did = NULL;
 #define MAX_SUBSTRINGS 30
@@ -204,31 +166,43 @@ static inline DetectDceIfaceData *DetectDceIfaceArgParse(const char *arg)
     return NULL;
 }
 
+
 /**
- * \internal
- * \brief Internal function that compares the dce interface version for this
- *        flow, to the signature's interface version specified using the
- *        dce_iface keyword.
- *
- * \param version  The dce interface version for this flow.
- * \param dce_data Pointer to the Signature's dce_iface keyword
- *                 state(DetectDceIfaceData *).
+ * \brief Registers the keyword handlers for the "dce_iface" keyword.
  */
-static inline int DetectDceIfaceMatchIfaceVersion(uint16_t version,
-                                                  DetectDceIfaceData *dce_data)
+void DetectDceIfaceRegister(void)
 {
-    switch (dce_data->op) {
-        case DETECT_DCE_IFACE_OP_LT:
-            return (version < dce_data->version);
-        case DETECT_DCE_IFACE_OP_GT:
-            return (version > dce_data->version);
-        case DETECT_DCE_IFACE_OP_EQ:
-            return (version == dce_data->version);
-        case DETECT_DCE_IFACE_OP_NE:
-            return (version != dce_data->version);
-        default:
-            return 1;
+    const char *eb;
+    int eo;
+    int opts = 0;
+
+    sigmatch_table[DETECT_DCE_IFACE].name = "dce_iface";
+    sigmatch_table[DETECT_DCE_IFACE].alproto = ALPROTO_DCERPC;
+    sigmatch_table[DETECT_DCE_IFACE].Match = NULL;
+    sigmatch_table[DETECT_DCE_IFACE].AppLayerMatch = DetectDceIfaceMatch;
+    sigmatch_table[DETECT_DCE_IFACE].Setup = DetectDceIfaceSetup;
+    sigmatch_table[DETECT_DCE_IFACE].Free  = DetectDceIfaceFree;
+    sigmatch_table[DETECT_DCE_IFACE].RegisterTests = DetectDceIfaceRegisterTests;
+
+    parse_regex = pcre_compile(DETECT_DCE_IFACE_PCRE_PARSE_ARGS, opts, &eb,
+                               &eo, NULL);
+    if (parse_regex == NULL) {
+        SCLogDebug("pcre compile of \"%s\" failed at offset %" PRId32 ": %s",
+                   DETECT_DCE_IFACE_PCRE_PARSE_ARGS, eo, eb);
+        goto error;
+    }
+
+    parse_regex_study = pcre_study(parse_regex, 0, &eb);
+    if (eb != NULL) {
+        SCLogDebug("pcre study failed: %s", eb);
+        goto error;
     }
+
+    return;
+
+ error:
+    /* we need to handle error?! */
+    return;
 }
 
 /**
diff --git a/src/detect-dce-iface.h b/src/detect-dce-iface.h
index 91f8836..cec67cd 100644
--- a/src/detect-dce-iface.h
+++ b/src/detect-dce-iface.h
@@ -23,4 +23,34 @@ typedef struct DetectDceIfaceData_ {
 void DetectDceIfaceRegister(void);
 void DetectDceIfaceRegisterTests(void);
 
+/** ------ inline functions ------ */
+
+/**
+ * \internal
+ * \brief Internal function that compares the dce interface version for this
+ *        flow, to the signature's interface version specified using the
+ *        dce_iface keyword.
+ *
+ * \param version  The dce interface version for this flow.
+ * \param dce_data Pointer to the Signature's dce_iface keyword
+ *                 state(DetectDceIfaceData *).
+ */
+static inline int DetectDceIfaceMatchIfaceVersion(uint16_t version,
+                                                  DetectDceIfaceData *dce_data)
+{
+    switch (dce_data->op) {
+        case DETECT_DCE_IFACE_OP_LT:
+            return (version < dce_data->version);
+        case DETECT_DCE_IFACE_OP_GT:
+            return (version > dce_data->version);
+        case DETECT_DCE_IFACE_OP_EQ:
+            return (version == dce_data->version);
+        case DETECT_DCE_IFACE_OP_NE:
+            return (version != dce_data->version);
+        default:
+            return 1;
+    }
+}
+
+
 #endif /* __DETECT_DCE_IFACE_H__ */
diff --git a/src/detect-dce-opnum.c b/src/detect-dce-opnum.c
index 2d13ce2..d620e3c 100644
--- a/src/detect-dce-opnum.c
+++ b/src/detect-dce-opnum.c
@@ -32,64 +32,6 @@ int DetectDceOpnumSetup(DetectEngineCtx *, Signature *s, SigMatch *m, char *arg)
 void DetectDceOpnumFree(void *);
 
 /**
- * \brief Registers the keyword handlers for the "dce_opnum" keyword.
- */
-void DetectDceOpnumRegister(void)
-{
-    const char *eb;
-    int eo;
-    int opts = 0;
-
-    sigmatch_table[DETECT_DCE_OPNUM].name = "dce_opnum";
-    sigmatch_table[DETECT_DCE_OPNUM].alproto = ALPROTO_DCERPC;
-    sigmatch_table[DETECT_DCE_OPNUM].Match = NULL;
-    sigmatch_table[DETECT_DCE_OPNUM].AppLayerMatch = DetectDceOpnumMatch;
-    sigmatch_table[DETECT_DCE_OPNUM].Setup = DetectDceOpnumSetup;
-    sigmatch_table[DETECT_DCE_OPNUM].Free  = DetectDceOpnumFree;
-    sigmatch_table[DETECT_DCE_OPNUM].RegisterTests = DetectDceOpnumRegisterTests;
-
-    parse_regex = pcre_compile(DETECT_DCE_OPNUM_PCRE_PARSE_ARGS, opts, &eb,
-                               &eo, NULL);
-    if (parse_regex == NULL) {
-        SCLogError(SC_ERR_PCRE_COMPILE, "pcre compile of \"%s\" failed at offset %" PRId32 ": %s",
-                   DETECT_DCE_OPNUM_PCRE_PARSE_ARGS, eo, eb);
-        goto error;
-    }
-
-    parse_regex_study = pcre_study(parse_regex, 0, &eb);
-    if (eb != NULL) {
-        SCLogError(SC_ERR_PCRE_STUDY, "pcre study failed: %s", eb);
-        goto error;
-    }
-
-    return;
-
- error:
-    /* we need to handle error?! */
-    return;
-}
-
-/**
- * \internal
- * \brief Creates and returns a new instance of DetectDceOpnumRange.
- *
- * \retval dor Pointer to the new instance DetectDceOpnumRange.
- */
-static inline DetectDceOpnumRange *DetectDceOpnumAllocDetectDceOpnumRange(void)
-{
-    DetectDceOpnumRange *dor = NULL;
-
-    if ( (dor = SCMalloc(sizeof(DetectDceOpnumRange))) == NULL) {
-        SCLogError(SC_ERR_MEM_ALLOC, "Error allocating memory");
-        exit(EXIT_FAILURE);
-    }
-    memset(dor, 0, sizeof(DetectDceOpnumRange));
-    dor->range1 = dor->range2 = DCE_OPNUM_RANGE_UNINITIALIZED;
-
-    return dor;
-}
-
-/**
  * \internal
  * \brief Parses the argument sent along with the "dce_opnum" keyword.
  *
@@ -98,7 +40,7 @@ static inline DetectDceOpnumRange *DetectDceOpnumAllocDetectDceOpnumRange(void)
  * \retval did Pointer to a DetectDceIfaceData instance that holds the data
  *             from the parsed arg.
  */
-static inline DetectDceOpnumData *DetectDceOpnumArgParse(const char *arg)
+static DetectDceOpnumData *DetectDceOpnumArgParse(const char *arg)
 {
     DetectDceOpnumData *dod = NULL;
 
@@ -219,6 +161,44 @@ static inline DetectDceOpnumData *DetectDceOpnumArgParse(const char *arg)
 }
 
 /**
+ * \brief Registers the keyword handlers for the "dce_opnum" keyword.
+ */
+void DetectDceOpnumRegister(void)
+{
+    const char *eb;
+    int eo;
+    int opts = 0;
+
+    sigmatch_table[DETECT_DCE_OPNUM].name = "dce_opnum";
+    sigmatch_table[DETECT_DCE_OPNUM].alproto = ALPROTO_DCERPC;
+    sigmatch_table[DETECT_DCE_OPNUM].Match = NULL;
+    sigmatch_table[DETECT_DCE_OPNUM].AppLayerMatch = DetectDceOpnumMatch;
+    sigmatch_table[DETECT_DCE_OPNUM].Setup = DetectDceOpnumSetup;
+    sigmatch_table[DETECT_DCE_OPNUM].Free  = DetectDceOpnumFree;
+    sigmatch_table[DETECT_DCE_OPNUM].RegisterTests = DetectDceOpnumRegisterTests;
+
+    parse_regex = pcre_compile(DETECT_DCE_OPNUM_PCRE_PARSE_ARGS, opts, &eb,
+                               &eo, NULL);
+    if (parse_regex == NULL) {
+        SCLogError(SC_ERR_PCRE_COMPILE, "pcre compile of \"%s\" failed at offset %" PRId32 ": %s",
+                   DETECT_DCE_OPNUM_PCRE_PARSE_ARGS, eo, eb);
+        goto error;
+    }
+
+    parse_regex_study = pcre_study(parse_regex, 0, &eb);
+    if (eb != NULL) {
+        SCLogError(SC_ERR_PCRE_STUDY, "pcre study failed: %s", eb);
+        goto error;
+    }
+
+    return;
+
+ error:
+    /* we need to handle error?! */
+    return;
+}
+
+/**
  * \brief App layer match function for the "dce_opnum" keyword.
  *
  * \param t       Pointer to the ThreadVars instance.
diff --git a/src/detect-dce-opnum.h b/src/detect-dce-opnum.h
index 4ae1e73..504f47d 100644
--- a/src/detect-dce-opnum.h
+++ b/src/detect-dce-opnum.h
@@ -21,4 +21,28 @@ typedef struct DetectDceOpnumData_ {
 void DetectDceOpnumRegister(void);
 void DetectDceOpnumRegisterTests(void);
 
+/** ------ inline functions ------ */
+
+/**
+ * \internal
+ * \brief Creates and returns a new instance of DetectDceOpnumRange.
+ *
+ * \retval dor Pointer to the new instance DetectDceOpnumRange.
+ */
+static inline DetectDceOpnumRange *DetectDceOpnumAllocDetectDceOpnumRange(void)
+{
+    DetectDceOpnumRange *dor = NULL;
+
+    if ( (dor = SCMalloc(sizeof(DetectDceOpnumRange))) == NULL) {
+        SCLogError(SC_ERR_MEM_ALLOC, "Error allocating memory");
+        exit(EXIT_FAILURE);
+    }
+    memset(dor, 0, sizeof(DetectDceOpnumRange));
+    dor->range1 = dor->range2 = DCE_OPNUM_RANGE_UNINITIALIZED;
+
+    return dor;
+}
+
+
+
 #endif /* __DETECT_DCE_OPNUM_H__ */
diff --git a/src/detect-engine-address.h b/src/detect-engine-address.h
index 70f3b54..e8e945c 100644
--- a/src/detect-engine-address.h
+++ b/src/detect-engine-address.h
@@ -4,10 +4,11 @@
  * \author Victor Julien
  */
 
-
 #ifndef __DETECT_ADDRESS_H__
 #define __DETECT_ADDRESS_H__
 
+#include "detect.h"
+
 /* prototypes */
 void DetectAddressRegister (void);
 void DetectAddressPrintMemory(void);
diff --git a/src/detect-engine-port.h b/src/detect-engine-port.h
index cbf3908..0aa93fe 100644
--- a/src/detect-engine-port.h
+++ b/src/detect-engine-port.h
@@ -1,6 +1,10 @@
 #ifndef __DETECT_PORT_H__
 #define __DETECT_PORT_H__
 
+/** \brief Port structure for detection engine */
+
+#include "detect.h"
+
 /* prototypes */
 void DetectPortRegister (void);
 
diff --git a/src/detect-engine-sigorder.c b/src/detect-engine-sigorder.c
index 48ca5e9..54b18fb 100644
--- a/src/detect-engine-sigorder.c
+++ b/src/detect-engine-sigorder.c
@@ -16,15 +16,6 @@
 #include "util-unittest.h"
 #include "util-debug.h"
 
-#define DETECT_FLOWVAR_NOT_USED   1
-#define DETECT_FLOWVAR_TYPE_READ  2
-#define DETECT_FLOWVAR_TYPE_SET   3
-
-#define DETECT_PKTVAR_NOT_USED   1
-#define DETECT_PKTVAR_TYPE_READ  2
-#define DETECT_PKTVAR_TYPE_SET   3
-
-
 /**
  * \brief Registers a keyword-based, signature ordering function
  *
@@ -72,153 +63,6 @@ static void SCSigRegisterSignatureOrderingFunc(DetectEngineCtx *de_ctx,
 }
 
 /**
- * \brief Returns the flowbit type set for this signature.  If more than one
- *        flowbit has been set for the same rule, we return the flowbit type of
- *        the maximum priority/value, where priority/value is maximum for the
- *        ones that set the value and the lowest for ones that read the value.
- *        If no flowbit has been set for the rule, we return 0, which indicates
- *        the least value amongst flowbit types.
- *
- * \param sig Pointer to the Signature from which the flowbit value has to be
- *            returned.
- *
- * \retval flowbits The flowbits type for this signature if it is set; if it is
- *                  not set, return 0
- */
-static inline int SCSigGetFlowbitsType(Signature *sig)
-{
-    SigMatch *sm = sig->match;
-    DetectFlowbitsData *fb = NULL;
-    int flowbits = 0;
-
-    while (sm != NULL) {
-        if (sm->type == DETECT_FLOWBITS) {
-            fb = (DetectFlowbitsData *)sm->ctx;
-            if (flowbits < fb->cmd)
-                flowbits = fb->cmd;
-        }
-
-        sm = sm->next;
-    }
-
-    return flowbits;
-}
-
-/**
- * \brief Returns whether the flowvar set for this rule, sets the flowvar or
- *        reads the flowvar.  If the rule sets the flowvar the function returns
- *        DETECT_FLOWVAR_TYPE_SET(3), if it reads the flowvar the function
- *        returns DETECT_FLOWVAR_TYPE_READ(2), and if flowvar is not used in this
- *        rule the function returns DETECT_FLOWVAR_NOT_USED(1)
- *
- * \param sig Pointer to the Signature from which the flowvar type has to be
- *            returned.
- *
- * \retval type DETECT_FLOWVAR_TYPE_SET(3) if the rule sets the flowvar,
- *              DETECT_FLOWVAR_TYPE_READ(2) if it reads, and
- *              DETECT_FLOWVAR_NOT_USED(1) if flowvar is not used.
- */
-static inline int SCSigGetFlowvarType(Signature *sig)
-{
-    SigMatch *sm = sig->match;
-    DetectPcreData *pd = NULL;
-    int type = DETECT_FLOWVAR_NOT_USED;
-
-    while (sm != NULL) {
-        pd = (DetectPcreData *)sm->ctx;
-        if (sm->type == DETECT_PCRE && pd->flags & DETECT_PCRE_CAPTURE_FLOW) {
-            type = DETECT_FLOWVAR_TYPE_SET;
-            return type;
-        }
-
-        if (sm->type == DETECT_FLOWVAR)
-            type = DETECT_FLOWVAR_TYPE_READ;
-
-        sm = sm->next;
-    }
-
-    return type;
-}
-
-/**
- * \brief Returns whether the pktvar set for this rule, sets the flowvar or
- *        reads the pktvar.  If the rule sets the pktvar the function returns
- *        DETECT_PKTVAR_TYPE_SET(3), if it reads the pktvar the function
- *        returns DETECT_PKTVAR_TYPE_READ(2), and if pktvar is not used in this
- *        rule the function returns DETECT_PKTVAR_NOT_USED(1)
- *
- * \param sig Pointer to the Signature from which the pktvar type has to be
- *            returned.
- *
- * \retval type DETECT_PKTVAR_TYPE_SET(3) if the rule sets the flowvar,
- *              DETECT_PKTVAR_TYPE_READ(2) if it reads, and
- *              DETECT_PKTVAR_NOT_USED(1) if pktvar is not used.
- */
-static inline int SCSigGetPktvarType(Signature *sig)
-{
-    SigMatch *sm = sig->match;
-    DetectPcreData *pd = NULL;
-    int type = DETECT_PKTVAR_NOT_USED;
-
-    while (sm != NULL) {
-        pd = (DetectPcreData *)sm->ctx;
-        if (sm->type == DETECT_PCRE && pd->flags & DETECT_PCRE_CAPTURE_PKT) {
-            type = DETECT_PKTVAR_TYPE_SET;
-            return type;
-        }
-
-        if (sm->type == DETECT_PKTVAR)
-            type = DETECT_PKTVAR_TYPE_READ;
-
-        sm = sm->next;
-    }
-
-    return type;
-}
-
-/**
- * \brief Processes the flowbits data for this signature and caches it for
- *        future use.  This is needed to optimize the sig_ordering module.
- *
- * \param sw The sigwrapper/signature for which the flowbits data has to be
- *           cached
- */
-static inline void SCSigProcessUserDataForFlowbits(SCSigSignatureWrapper *sw)
-{
-    *((int *)(sw->user[SC_RADIX_USER_DATA_FLOWBITS])) = SCSigGetFlowbitsType(sw->sig);
-
-    return;
-}
-
-/**
- * \brief Processes the flowvar data for this signature and caches it for
- *        future use.  This is needed to optimize the sig_ordering module.
- *
- * \param sw The sigwrapper/signature for which the flowvar data has to be
- *           cached
- */
-static inline void SCSigProcessUserDataForFlowvar(SCSigSignatureWrapper *sw)
-{
-    *((int *)(sw->user[SC_RADIX_USER_DATA_FLOWVAR])) = SCSigGetFlowvarType(sw->sig);
-
-    return;
-}
-
-/**
- * \brief Processes the pktvar data for this signature and caches it for
- *        future use.  This is needed to optimize the sig_ordering module.
- *
- * \param sw The sigwrapper/signature for which the pktvar data has to be
- *           cached
- */
-static inline void SCSigProcessUserDataForPktvar(SCSigSignatureWrapper *sw)
-{
-    *((int *)(sw->user[SC_RADIX_USER_DATA_PKTVAR])) = SCSigGetPktvarType(sw->sig);
-
-    return;
-}
-
-/**
  * \brief Orders an incoming Signature based on its action
  *
  * \param de_ctx Pointer to the detection engine context from which the
@@ -728,49 +572,6 @@ static void SCSigOrderByPriority(DetectEngineCtx *de_ctx,
 }
 
 /**
- * \brief Creates a Wrapper around the Signature
- *
- * \param Pointer to the Signature to be wrapped
- *
- * \retval sw Pointer to the wrapper that holds the signature
- */
-static inline SCSigSignatureWrapper *SCSigAllocSignatureWrapper(Signature *sig)
-{
-    SCSigSignatureWrapper *sw = NULL;
-    int i = 0;
-
-    if ( (sw = SCMalloc(sizeof(SCSigSignatureWrapper))) == NULL) {
-        printf("Error allocating memory\n");
-        exit(EXIT_FAILURE);
-    }
-    memset(sw, 0, sizeof(SCSigSignatureWrapper));
-
-    sw->sig = sig;
-
-    if ( (sw->user = SCMalloc(SC_RADIX_USER_DATA_MAX * sizeof(int *))) == NULL) {
-        printf("Error allocating memory\n");
-        exit(EXIT_FAILURE);
-    }
-    memset(sw->user, 0, SC_RADIX_USER_DATA_MAX * sizeof(int *));
-
-    for (i = 0; i < SC_RADIX_USER_DATA_MAX; i++) {
-        if ( (sw->user[i] = SCMalloc(sizeof(int))) == NULL) {
-            printf("Error allocating memory\n");
-            exit(EXIT_FAILURE);
-        }
-        memset(sw->user[i], 0, sizeof(int));
-    }
-
-    /* Process data from the signature into a cache for further use by the
-     * sig_ordering module */
-    SCSigProcessUserDataForFlowbits(sw);
-    SCSigProcessUserDataForFlowvar(sw);
-    SCSigProcessUserDataForPktvar(sw);
-
-    return sw;
-}
-
-/**
  * \brief Orders the signatures
  *
  * \param de_ctx Pointer to the Detection Engine Context that holds the
diff --git a/src/detect-engine-sigorder.h b/src/detect-engine-sigorder.h
index c79e040..7611d7f 100644
--- a/src/detect-engine-sigorder.h
+++ b/src/detect-engine-sigorder.h
@@ -5,6 +5,29 @@
 #ifndef __DETECT_ENGINE_SIGORDER_H__
 #define __DETECT_ENGINE_SIGORDER_H__
 
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <pcre.h>
+
+#include "suricata-common.h"
+#include "detect.h"
+#include "detect-flowbits.h"
+#include "detect-engine-sigorder.h"
+#include "detect-pcre.h"
+
+#include "util-unittest.h"
+#include "util-debug.h"
+
+#define DETECT_FLOWVAR_NOT_USED   1
+#define DETECT_FLOWVAR_TYPE_READ  2
+#define DETECT_FLOWVAR_TYPE_SET   3
+
+#define DETECT_PKTVAR_NOT_USED   1
+#define DETECT_PKTVAR_TYPE_READ  2
+#define DETECT_PKTVAR_TYPE_SET   3
+
+
 /**
  * \brief Different kinds of helper data that can be used by the signature
  *        ordering module.  Used by the "user" field in SCSigSignatureWrapper
@@ -56,4 +79,205 @@ void SCSigRegisterSignatureOrderingFuncs(DetectEngineCtx *);
 void SCSigRegisterSignatureOrderingTests(void);
 void SCSigSignatureOrderingModuleCleanup(DetectEngineCtx *);
 
+/** ------ inline functions ------ */
+static inline SCSigSignatureWrapper *SCSigAllocSignatureWrapper(Signature *);
+static inline int SCSigGetFlowbitsType(Signature *);
+static inline int SCSigGetFlowvarType(Signature *);
+static inline int SCSigGetPktvarType(Signature *);
+static inline void SCSigProcessUserDataForFlowbits(SCSigSignatureWrapper *);
+static inline void SCSigProcessUserDataForFlowvar(SCSigSignatureWrapper *);
+static inline void SCSigProcessUserDataForPktvar(SCSigSignatureWrapper *);
+
+/**
+ * \brief Creates a Wrapper around the Signature
+ *
+ * \param Pointer to the Signature to be wrapped
+ *
+ * \retval sw Pointer to the wrapper that holds the signature
+ */
+static inline SCSigSignatureWrapper *SCSigAllocSignatureWrapper(Signature *sig)
+{
+    SCSigSignatureWrapper *sw = NULL;
+    int i = 0;
+
+    if ( (sw = SCMalloc(sizeof(SCSigSignatureWrapper))) == NULL) {
+        printf("Error allocating memory\n");
+        exit(EXIT_FAILURE);
+    }
+    memset(sw, 0, sizeof(SCSigSignatureWrapper));
+
+    sw->sig = sig;
+
+    if ( (sw->user = SCMalloc(SC_RADIX_USER_DATA_MAX * sizeof(int *))) == NULL) {
+        printf("Error allocating memory\n");
+        exit(EXIT_FAILURE);
+    }
+    memset(sw->user, 0, SC_RADIX_USER_DATA_MAX * sizeof(int *));
+
+    for (i = 0; i < SC_RADIX_USER_DATA_MAX; i++) {
+        if ( (sw->user[i] = SCMalloc(sizeof(int))) == NULL) {
+            printf("Error allocating memory\n");
+            exit(EXIT_FAILURE);
+        }
+        memset(sw->user[i], 0, sizeof(int));
+    }
+
+    /* Process data from the signature into a cache for further use by the
+     * sig_ordering module */
+    SCSigProcessUserDataForFlowbits(sw);
+    SCSigProcessUserDataForFlowvar(sw);
+    SCSigProcessUserDataForPktvar(sw);
+
+    return sw;
+}
+
+/**
+ * \brief Returns the flowbit type set for this signature.  If more than one
+ *        flowbit has been set for the same rule, we return the flowbit type of
+ *        the maximum priority/value, where priority/value is maximum for the
+ *        ones that set the value and the lowest for ones that read the value.
+ *        If no flowbit has been set for the rule, we return 0, which indicates
+ *        the least value amongst flowbit types.
+ *
+ * \param sig Pointer to the Signature from which the flowbit value has to be
+ *            returned.
+ *
+ * \retval flowbits The flowbits type for this signature if it is set; if it is
+ *                  not set, return 0
+ */
+static inline int SCSigGetFlowbitsType(Signature *sig)
+{
+    SigMatch *sm = sig->match;
+    DetectFlowbitsData *fb = NULL;
+    int flowbits = 0;
+
+    while (sm != NULL) {
+        if (sm->type == DETECT_FLOWBITS) {
+            fb = (DetectFlowbitsData *)sm->ctx;
+            if (flowbits < fb->cmd)
+                flowbits = fb->cmd;
+        }
+
+        sm = sm->next;
+    }
+
+    return flowbits;
+}
+
+/**
+ * \brief Returns whether the flowvar set for this rule, sets the flowvar or
+ *        reads the flowvar.  If the rule sets the flowvar the function returns
+ *        DETECT_FLOWVAR_TYPE_SET(3), if it reads the flowvar the function
+ *        returns DETECT_FLOWVAR_TYPE_READ(2), and if flowvar is not used in this
+ *        rule the function returns DETECT_FLOWVAR_NOT_USED(1)
+ *
+ * \param sig Pointer to the Signature from which the flowvar type has to be
+ *            returned.
+ *
+ * \retval type DETECT_FLOWVAR_TYPE_SET(3) if the rule sets the flowvar,
+ *              DETECT_FLOWVAR_TYPE_READ(2) if it reads, and
+ *              DETECT_FLOWVAR_NOT_USED(1) if flowvar is not used.
+ */
+static inline int SCSigGetFlowvarType(Signature *sig)
+{
+    SigMatch *sm = sig->match;
+    DetectPcreData *pd = NULL;
+    int type = DETECT_FLOWVAR_NOT_USED;
+
+    while (sm != NULL) {
+        pd = (DetectPcreData *)sm->ctx;
+        if (sm->type == DETECT_PCRE && pd->flags & DETECT_PCRE_CAPTURE_FLOW) {
+            type = DETECT_FLOWVAR_TYPE_SET;
+            return type;
+        }
+
+        if (sm->type == DETECT_FLOWVAR)
+            type = DETECT_FLOWVAR_TYPE_READ;
+
+        sm = sm->next;
+    }
+
+    return type;
+}
+
+/**
+ * \brief Returns whether the pktvar set for this rule, sets the flowvar or
+ *        reads the pktvar.  If the rule sets the pktvar the function returns
+ *        DETECT_PKTVAR_TYPE_SET(3), if it reads the pktvar the function
+ *        returns DETECT_PKTVAR_TYPE_READ(2), and if pktvar is not used in this
+ *        rule the function returns DETECT_PKTVAR_NOT_USED(1)
+ *
+ * \param sig Pointer to the Signature from which the pktvar type has to be
+ *            returned.
+ *
+ * \retval type DETECT_PKTVAR_TYPE_SET(3) if the rule sets the flowvar,
+ *              DETECT_PKTVAR_TYPE_READ(2) if it reads, and
+ *              DETECT_PKTVAR_NOT_USED(1) if pktvar is not used.
+ */
+static inline int SCSigGetPktvarType(Signature *sig)
+{
+    SigMatch *sm = sig->match;
+    DetectPcreData *pd = NULL;
+    int type = DETECT_PKTVAR_NOT_USED;
+
+    while (sm != NULL) {
+        pd = (DetectPcreData *)sm->ctx;
+        if (sm->type == DETECT_PCRE && pd->flags & DETECT_PCRE_CAPTURE_PKT) {
+            type = DETECT_PKTVAR_TYPE_SET;
+            return type;
+        }
+
+        if (sm->type == DETECT_PKTVAR)
+            type = DETECT_PKTVAR_TYPE_READ;
+
+        sm = sm->next;
+    }
+
+    return type;
+}
+
+/**
+ * \brief Processes the flowbits data for this signature and caches it for
+ *        future use.  This is needed to optimize the sig_ordering module.
+ *
+ * \param sw The sigwrapper/signature for which the flowbits data has to be
+ *           cached
+ */
+static inline void SCSigProcessUserDataForFlowbits(SCSigSignatureWrapper *sw)
+{
+    *((int *)(sw->user[SC_RADIX_USER_DATA_FLOWBITS])) = SCSigGetFlowbitsType(sw->sig);
+
+    return;
+}
+
+/**
+ * \brief Processes the flowvar data for this signature and caches it for
+ *        future use.  This is needed to optimize the sig_ordering module.
+ *
+ * \param sw The sigwrapper/signature for which the flowvar data has to be
+ *           cached
+ */
+static inline void SCSigProcessUserDataForFlowvar(SCSigSignatureWrapper *sw)
+{
+    *((int *)(sw->user[SC_RADIX_USER_DATA_FLOWVAR])) = SCSigGetFlowvarType(sw->sig);
+
+    return;
+}
+
+/**
+ * \brief Processes the pktvar data for this signature and caches it for
+ *        future use.  This is needed to optimize the sig_ordering module.
+ *
+ * \param sw The sigwrapper/signature for which the pktvar data has to be
+ *           cached
+ */
+static inline void SCSigProcessUserDataForPktvar(SCSigSignatureWrapper *sw)
+{
+    *((int *)(sw->user[SC_RADIX_USER_DATA_PKTVAR])) = SCSigGetPktvarType(sw->sig);
+
+    return;
+}
+
+
+
 #endif /* __DETECT_ENGINE_SIGORDER_H__ */
diff --git a/src/detect-fast-pattern.c b/src/detect-fast-pattern.c
index 86cca74..9201710 100644
--- a/src/detect-fast-pattern.c
+++ b/src/detect-fast-pattern.c
@@ -78,11 +78,6 @@ int DetectFastPatternSetup(DetectEngineCtx *de_ctx, Signature *s, SigMatch *m,
 
 #ifdef UNITTESTS
 
-inline SigGroupHead *SigMatchSignaturesGetSgh(ThreadVars *,
-                                              DetectEngineCtx *,
-                                              DetectEngineThreadCtx *,
-                                              Packet *);
-
 /**
  * \test Checks if a fast_pattern is registered in a Signature
  */
diff --git a/src/detect-stream_size.c b/src/detect-stream_size.c
index b73526b..f9b4946 100644
--- a/src/detect-stream_size.c
+++ b/src/detect-stream_size.c
@@ -63,50 +63,6 @@ error:
 }
 
 /**
- * \brief Function to comapre the stream size against defined size in the user
- *  options.
- *
- *  \param  diff    The stream size of server or client stream.
- *  \param  stream_size User defined stream size
- *  \param  mode    The mode defined by user.
- *
- *  \retval 1 on success and 0 on failure.
- */
-
-static inline int DetectStreamSizeCompare (uint32_t diff, uint32_t stream_size, uint8_t mode) {
-
-    int ret = 0;
-    switch (mode) {
-        case DETECTSSIZE_LT:
-            if (diff < stream_size)
-                ret = 1;
-            break;
-        case DETECTSSIZE_LEQ:
-            if (diff <= stream_size)
-                ret = 1;
-            break;
-        case DETECTSSIZE_EQ:
-            if (diff == stream_size)
-                ret = 1;
-            break;
-        case DETECTSSIZE_NEQ:
-            if (diff != stream_size)
-                ret = 1;
-            break;
-        case DETECTSSIZE_GEQ:
-            if (diff >= stream_size)
-                ret = 1;
-            break;
-        case DETECTSSIZE_GT:
-            if (diff > stream_size)
-                ret = 1;
-            break;
-    }
-
-    return ret;
-}
-
-/**
  * \brief This function is used to match Stream size rule option on a packet with those passed via stream_size:
  *
  * \param t pointer to thread vars
diff --git a/src/detect-stream_size.h b/src/detect-stream_size.h
index 61e67a9..1201830 100644
--- a/src/detect-stream_size.h
+++ b/src/detect-stream_size.h
@@ -28,5 +28,52 @@ typedef struct DetectStreamSizeData_ {
 
 void DetectStreamSizeRegister(void);
 
+/** ------ inline functions ------ */
+
+/**
+ * \brief Function to comapre the stream size against defined size in the user
+ *  options.
+ *
+ *  \param  diff    The stream size of server or client stream.
+ *  \param  stream_size User defined stream size
+ *  \param  mode    The mode defined by user.
+ *
+ *  \retval 1 on success and 0 on failure.
+ */
+
+static inline int DetectStreamSizeCompare (uint32_t diff, uint32_t stream_size, uint8_t mode) {
+
+    int ret = 0;
+    switch (mode) {
+        case DETECTSSIZE_LT:
+            if (diff < stream_size)
+                ret = 1;
+            break;
+        case DETECTSSIZE_LEQ:
+            if (diff <= stream_size)
+                ret = 1;
+            break;
+        case DETECTSSIZE_EQ:
+            if (diff == stream_size)
+                ret = 1;
+            break;
+        case DETECTSSIZE_NEQ:
+            if (diff != stream_size)
+                ret = 1;
+            break;
+        case DETECTSSIZE_GEQ:
+            if (diff >= stream_size)
+                ret = 1;
+            break;
+        case DETECTSSIZE_GT:
+            if (diff > stream_size)
+                ret = 1;
+            break;
+    }
+
+    return ret;
+}
+
+
 #endif	/* _DETECT_STREAM_SIZE_H */
 
